commit 60c20a314d57693a68e8c8a61d463202f229a954
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Mon Oct 11 14:28:32 2021

    libstdc++: Fix std::numeric_limits::lowest() test for strict modes
    
    This test uses std::is_integral to decide whether we are testing an
    integral or floating-point type. But that fails for __int128 because
    is_integral<__int128> is false in strict modes. By using
    numeric_limits::is_integer instead we get the right answer for all types
    that have a numeric_limits specialization.
    
    We can also simplify the test by removing the unnecessary tag
    dispatching.
    
    libstdc++-v3/ChangeLog:
    
            * testsuite/18_support/numeric_limits/lowest.cc: Use
            numeric_limits<T>::is_integer instead of is_integral<T>::value.
    
    (cherry picked from commit 45ba5426c129993704a73e6ace4016eaa950d7ee)

diff --git a/libstdc++-v3/testsuite/18_support/numeric_limits/lowest.cc b/libstdc++-v3/testsuite/18_support/numeric_limits/lowest.cc
index 49c1c4d6953..039080f42d0 100644
--- a/libstdc++-v3/testsuite/18_support/numeric_limits/lowest.cc
+++ b/libstdc++-v3/testsuite/18_support/numeric_limits/lowest.cc
@@ -23,30 +23,20 @@
 // 18.2.1.1 template class numeric_limits
 
 #include <limits>
-#include <type_traits>
 #include <testsuite_hooks.h>
 
 template<typename T>
   void
-  do_test(std::true_type)
+  do_test()
   {
     T limits_min = std::numeric_limits<T>::min();
-    VERIFY( std::numeric_limits<T>::lowest() == limits_min );
-  }
-
-template<typename T>
-  void
-  do_test(std::false_type)
-  {
     T limits_max = std::numeric_limits<T>::max();
-    VERIFY( std::numeric_limits<T>::lowest() == -limits_max );
+    if (std::numeric_limits<T>::is_integer)
+      VERIFY( std::numeric_limits<T>::lowest() == limits_min );
+    else
+      VERIFY( std::numeric_limits<T>::lowest() == -limits_max );
   }
 
-template<typename Tp>
-  void
-  do_test()
-  { do_test<Tp>(typename std::is_integral<Tp>::type()); }
-
 void test01()
 {
   do_test<char>();

